//
//  QHVCDownloader.h
//  QHVCPlayerKit
//
//  Created by 叶恩龙 on 2023/10/11.
//  Copyright © 2023 qihoo 360. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <QHVCPlayerKit/QHVCPlayerEnum.h>

NS_ASSUME_NONNULL_BEGIN

@interface QHVCDownloader : NSObject

/**
 下载器状态
 */
@property (nonatomic, assign, readonly) QHVCDownloaderStatus status;


+ (instancetype)sharedInstance;

/**
@param url 源文件地址(同时支持网络和本地资源)
@param path 要保存的文件全路径（文件夹路径必须存在，包括文件名以及拓展名）
@param options 可选参数
@{
 @"start": NSNumber, //开始截取时间
 @"end": NSNumber, //结束截取时间
 @"width": NSNumber, // 输出视频width，默认取原视频width
 @"height": NSNumber, // 输出视频height，默认取原视频height
 @"bitrate":  NSNumber, // 输出视频bitrate，默认取原视频bitrate
 @"fps":  NSNumber, // 输出视频fps，默认取原视频fps
 @"key": NSString, // 解密密钥
 @"decryptType": QHVCDecryptType // 解密算法类型
 @"rotate": NSNumber // 输出视频旋转角度
 }
@param progressHandler 进度回调(1~100)100表示完成
@param completionHandler 结果回调
@return yes 参数合法 no 参数非法
*/
- (BOOL)startWithUrl:(NSString *)url savePath:(NSString *)path options:(NSDictionary *_Nullable)options progress:(nullable void(^)(NSInteger progress))progressHandler completion:(nullable void (^)(BOOL success))completionHandler;


/**
停止下载
@return yes调用合法 no调用非法
*/
- (BOOL)stop;

@end

NS_ASSUME_NONNULL_END
